/*
 * USART.c
 *
 * Created: 08.10.2011 19:03:57
 *  Author: BjoernC
 */ 

#include "UART.h"
#include "main.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

static void initHW ( void ){
	uint16_t BaudTimerVal =( uint16_t ) ( ( uint32_t ) F_CPU / ( 16UL * UART_BAUDRATE ) - 1 );
	UBRRH = (uint8_t) ( ( BaudTimerVal >> 8 ) & 0xFF );
	UBRRL = (uint8_t) ( BaudTimerVal & 0xFF );
	
	UCSRB = ( 1 << RXEN  )|( 1 << TXEN  )|( 1 << RXCIE );
	UCSRC = ( 1 << URSEL )|( 1 << UCSZ1 )|( 1 << UCSZ0 );
	
	do{
		
		UDR;
		
	}while( UCSRA & ( 1 << RXC ) );
	
	UCSRA = ( 1 << RXC )|( 1 << TXC );
	
	return;
}

void initUART ( void ){
	//SREG sichern...
	uint8_t sreg = SREG;
	//interrupts definiert deaktivieren...
	cli();
	//HW initialisieren...
	initHW();
	//SREG zurckschreiben...
	SREG = sreg;
	return ;	
}
//test var to prefent optimizations
volatile uint8_t tst;

ISR(USART_RXC_vect){
	DDRC |=2;
	PORTC|=2;
	tst=UDR;
	PORTC&=~2;
	return;
}	

ISR(USART_UDRE_vect){
	static uint8_t cnt=0;
	DDRC |=1;
	PORTC |= 1;

	UDR = 0xAA;

	PORTC &= ~1;
	cnt++;
	//cnt>=5 works, cnt>=6 doesn't work...
	if(cnt>=6){
		cnt=0;
		UCSRB &= ~ ( 1 << UDRIE );
	}
	return;
}