/*
 * main.c
 *
 * Created: 08.10.2011 18:56:44
 *  Author: BjoernC
 */ 
#include "main.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "UART.h"

void initLED ( void );

ISR(BADISR_vect){
	SET_LED_RD_4;
	while(1);
	return;
}

int main ( void ){
	initUART ();
	initLED  ();
	//interrupts activated...
	sei();
	SET_LED_GN_1;
	while(1){
		//enable UART Register Empty interrupt
		UCSRB |= ( 1 << UDRIE );
		//wait some time
		_delay_ms(12);
						
	}		
}

void initLED ( void ){
	DDRB = (1<<4)|(1<<3)|(1<<2)|(1<<1)|(1<<0);
	//shows, that every LED is working correctly
	for(uint8_t i=0; i < 5; i++){
		PORTB|=(1<<i);
		_delay_ms(250);
		PORTB&=~(1<<i);
		_delay_ms(50);
	}
	return;
}